//Copyright (c) Microsoft Corporation.  All rights reserved.

using System.Diagnostics;
using System.Net;
using System.Threading;
using Microsoft.WindowsAzure.ServiceRuntime;

namespace Microsoft.Ted.Wacel.Demo.Worker
{
    public class WorkerRole : RoleEntryPoint
    {
        RandomCube mRandomCube = new RandomCube();
        public override void Run()
        {
            // This is a sample worker implementation. Replace with your logic.
            Trace.TraceInformation("Microsoft.Ted.Wacel.Demo.Worker entry point called", "Information");
            mRandomCube.Start();
            while (true)
            {
                Thread.Sleep(10000);
                Trace.TraceInformation("Working", "Information");
            }
        }

        public override bool OnStart()
        {
            // Set the maximum number of concurrent connections 
            ServicePointManager.DefaultConnectionLimit = 12;

            // For information on handling configuration changes
            // see the MSDN topic at http://go.microsoft.com/fwlink/?LinkId=166357.

            return base.OnStart();
        }
        public override void OnStop()
        {
            base.OnStop();
            mRandomCube.Stop();
        }
    }
}
