﻿//Copyright (c) Microsoft Corporation.  All rights reserved.

using Microsoft.Ted.Wacel;
using System;

namespace Microsoft.Ted.Wacel.TestConsole
{
    public class CachedArrayTester
    {
        public static void ReadWriteArrayItem()
        {
            CachedArray<int> array = new CachedArray<int>("my_array", 10);
            array[0] = 1234;
            VisualTester.AreEqual(1234, array[0]);
        }
        public static void WithoutRegion()
        {
            CachedArray<int> array = new CachedArray<int>("my_array", int.MaxValue);
            array[int.MaxValue-1] = 1234;
            VisualTester.AreEqual(1234, array[int.MaxValue-1]);
        }
        public static void ReadWithoutWrite()
        {
            CachedArray<int> array = new CachedArray<int>("my_array", int.MaxValue);
            int value = array[4567];
            VisualTester.AreEqual(0, value);
        }
        public static void IndexBoundary()
        {
            CachedArray<int> array = new CachedArray<int>("my_array", 10);
            try
            {
                array[10] = 1234;
                VisualTester.Assert(false);
            }
            catch (IndexOutOfRangeException)
            {
                VisualTester.Assert(true);
            }
            catch (Exception exp)
            {
                VisualTester.Assert(false, exp.Message);
            }
        }
        public static void Length()
        {
            CachedArray<int> array = new CachedArray<int>("my_array", 10);
            VisualTester.AreEqual(10, array.Length);
        }
        public static void OutofIndex()
        {
            CachedArray<int> array = new CachedArray<int>("my_array", 10);
            try
            {
                array[11] = 1234;
                VisualTester.Assert(false);
            }
            catch (IndexOutOfRangeException)
            {
                VisualTester.Assert(true);
            }
            catch (Exception exp)
            {
                VisualTester.Assert(false, exp.Message);
            }
        }
        public static void LoopAccess()
        {
            CachedArray<int> array = new CachedArray<int>("my_array", 10);
            for (int i = 0; i < array.Length; i++)
                array[i] = i;
            for (int i = 0; i < array.Length; i++)
                array[i] += array[i];
            VisualTester.AreEqual(18, array[9]);
        }
    }
}
