﻿//Copyright (c) Microsoft Corporation. All rights reserved.

using Microsoft.Ted.Wacel.TestConsole.Properties;
using Microsoft.Ted.Wacel.TableStorage;
using System;
using System.Diagnostics;
using System.Threading;

namespace Microsoft.Ted.Wacel.TestConsole
{
    public class CloudTableStorageTester
    {
        public static void  BasicCrud()
        {
            CloudTableStorage<Customer> storage = new CloudTableStorage<Customer>("ID", Settings.Default.StorageConnectionString, "customers", false);

            var customer = storage.Read("100", partitionId: "100");
            if (customer != null)
                storage.Delete("100", partitionId: "100");

            DateTime time = DateTime.UtcNow;

            storage.Insert(new Customer { ID = 100, Name = "This is a customer.", Value = 123.456, Time = time});
            
            customer = storage.Read("100");

            VisualTester.IsNotNull(customer);
            VisualTester.AreEqual(100, customer.ID);
            VisualTester.AreEqual("This is a customer.", customer.Name);
            VisualTester.AreEqual(123.456, customer.Value);
            VisualTester.AreEqual(0, (customer.Time-time).TotalSeconds);

            storage.Delete("100");
            customer = storage.Read("100");
            VisualTester.IsNull(customer);
            
        }
    }
   
}
