﻿//Copyright (c) Microsoft Corporation. All rights reserved.

using Microsoft.Ted.Wacel;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Microsoft.Ted.Wacel.TestConsole.PerformanceTests
{
    public class CompressedCircularPerfTest
    {
        public static int Add(Stopwatch watch)
        {
            int count = 200;
            string load = new string('X', 1024);
            CachedCompressedCircularBuffer buffer = new CachedCompressedCircularBuffer("perf_compressed", 1, batchSize: 5);
            watch.Restart();
            for (int i = 0; i < count; i++)
                buffer.Add(load);
            watch.Stop();
            return count;
        }
        public static int AddWithLargeBatch(Stopwatch watch)
        {
            int count = 2000;
            string load = new string('X', 1024);
            CachedCompressedCircularBuffer buffer = new CachedCompressedCircularBuffer("perf_compressed", 1, batchSize: 400);
            watch.Restart();
            for (int i = 0; i < count; i++)
                buffer.Add(load);
            watch.Stop();
            return count;
        }
    }
}
