﻿//Copyright (c) Microsoft Corporation.  All rights reserved.

using Microsoft.ApplicationServer.Caching;
using Microsoft.Ted.Wacel.Cache;

namespace Microsoft.Ted.Wacel
{
    public class CachedArray<T>:Array<T>
    {
        public CachedArray(string name, long size)
            : base(name, size,
                    new WindowsAzureCacheDataProvider(new DataCache(), name) { Configuration = new WindowsAzureCacheConfiguration() },
                    new WindowsAzureCachLockProvider(new DataCache(), name))
        {
        }
    }
}
