﻿//Copyright (c) Microsoft Corporation.  All rights reserved.

using Microsoft.ApplicationServer.Caching;
using Microsoft.Ted.Wacel.Cache;

namespace Microsoft.Ted.Wacel
{
    public class CachedCompressedCircularBuffer: Base.CompressedCircularBuffer
    {
        public CachedCompressedCircularBuffer(string name, long size, int batchSize = 1, bool avoidDuplicatedRead = true)
            : base(name, size, 
                new WindowsAzureCacheDataProvider(new DataCache(), name) {Configuration = new WindowsAzureCacheConfiguration() { WriteBatchSize = batchSize }},
                new WindowsAzureCachLockProvider(new DataCache(), name), avoidDuplicatedRead)
        {

        }
    }
}
