﻿//Copyright (c) Microsoft Corporation.  All rights reserved.

using Microsoft.ApplicationServer.Caching;
using Microsoft.Ted.Wacel.Base;
using Microsoft.Ted.Wacel.Cache;
using System;

namespace Microsoft.Ted.Wacel
{
    public class CachedCube:Base.Cube
    {
        public CachedCube(string name)
            : base(name,
                 new MasterDetails<string, string>(name + "batches",
                    new WindowsAzureCacheDataProvider(new DataCache(), name + "batches") {Configuration = new WindowsAzureCacheConfiguration()},
                    new WindowsAzureCachLockProvider(new DataCache(), name + "batchlocks")),
                new WindowsAzureCacheDataProvider(new DataCache(), name) {Configuration = new WindowsAzureCacheConfiguration()},
                new WindowsAzureCachLockProvider(new DataCache(), name))
        {

        }
        public static CachedCube SimpleCube
        {
            get
            {
                CachedCube ret = new CachedCube("SimpleCube");
                ret.AddDimension(Dimension.GetTimeDimensionMonthDays(DateTime.Now.Year));
                return ret;
            }
        }
    }
}
