﻿//Copyright (c) Microsoft Corporation. All rights reserved.

using Microsoft.ApplicationServer.Caching;
using Microsoft.Ted.Wacel.Cache;

namespace Microsoft.Ted.Wacel
{
    public class CachedQueue<T>: Base.Queue<T>
    {
        public CachedQueue(string name)
            :this(name, long.MaxValue-1)
        {
        }
        public CachedQueue(string name, long maxLength)
            : base(name, maxLength, 
                new WindowsAzureCacheDataProvider(new DataCache(), name) {Configuration = new WindowsAzureCacheConfiguration()},
                new WindowsAzureCachLockProvider(new DataCache(), name))
        {

        }
    }
}
