﻿//Copyright (c) Microsoft Corporation.  All rights reserved.

using Microsoft.ApplicationServer.Caching;
using Microsoft.Ted.Wacel.Base;
using Microsoft.Ted.Wacel.Cache;
using Microsoft.Ted.Wacel.TableStorage;
using System;

namespace Microsoft.Ted.Wacel
{
    public class Cube:Base.Cube
    {
        public Cube(string name, string connectionString)
            : base(name,
                new MasterDetails<string, string>(name + "batches",
                    new InMemoryDataProvider() { Configuration = new DataProviderConfiguration()  },
                    new TableStorageLockProvider(connectionString, name + "batchlocks")),
                new CacheTableProviderPair<NodeData>(new DataCache(), connectionString, name,
                    new WindowsAzureCacheConfiguration(),
                    new TableStorageConfiguration { WriteBatchSize = 1 }),
                new TableStorageLockProvider(connectionString, name + "lock"))
        {

        }
        public static Cube GetSimpleCube(string connectionString)
        {
            Cube ret = new Cube("simplecube", connectionString);
            ret.AddDimension(Dimension.GetTimeDimensionMonthDays(DateTime.Now.Year));
            return ret;
        }
    }
}
