﻿//Copyright (c) Microsoft Corporation. All rights reserved.

using Microsoft.ApplicationServer.Caching;
using Microsoft.Ted.Wacel.Base;
using Microsoft.Ted.Wacel.Cache;
using Microsoft.Ted.Wacel.TableStorage;

namespace Microsoft.Ted.Wacel
{
    public class Queue<T>:Base.Queue<T>
    {
        public Queue(string name, string connectionString)
            :this(name, long.MaxValue-1, connectionString)
        {
        }
         public Queue(string name, long size, string connectionString)
            : base(name, size,
                new CacheTableProviderPair<T>(new DataCache(), connectionString, name,
                    new WindowsAzureCacheConfiguration(),
                    new TableStorageConfiguration()),
                new TableStorageLockProvider(connectionString, name + "locks"))
        {
        }
         public Queue(string name, long size, IDataProvider dataProvider, ILockProvider lockProvider)
            :base(name, size, dataProvider, lockProvider)
        {
        }
    }
}
