﻿//Copyright (c) Microsoft Corporation.  All rights reserved.

using Microsoft.Ted.Wacel.TableStorage;

namespace Microsoft.Ted.Wacel
{
    public class TableStorageQueue<T>: Base.Queue<T>
    {
        public TableStorageQueue(string name, string connectionString)
            :this(name, long.MaxValue-1, connectionString)
        {
        }
        public TableStorageQueue(string name, long maxLength, string connectionString)
            : base(name, maxLength, 
                new TableStorageDataProvider<T>(connectionString, name) {Configuration = new TableStorageConfiguration()},
                new TableStorageLockProvider(connectionString, name))
        {

        }
    }
}
